'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var cx = require('clsx');
var Highlight = require('prism-react-renderer');
var radixIcons_esm = require('../../../node_modules/@modulz/radix-icons/dist/radix-icons.esm.js');
var core = require('@mantine/core');
var hooks = require('@mantine/hooks');
var prismTheme = require('./prism-theme.js');
var Prism_styles = require('./Prism.styles.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e['default'] : e; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var cx__default = /*#__PURE__*/_interopDefaultLegacy(cx);
var Highlight__default = /*#__PURE__*/_interopDefaultLegacy(Highlight);

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
function Prism(_a) {
  var _b = _a, {
    className,
    style,
    children,
    language,
    noCopy = false,
    themeOverride,
    classNames,
    styles,
    copyLabel = "Copy code",
    copiedLabel = "Copied"
  } = _b, others = __objRest(_b, [
    "className",
    "style",
    "children",
    "language",
    "noCopy",
    "themeOverride",
    "classNames",
    "styles",
    "copyLabel",
    "copiedLabel"
  ]);
  const theme = core.useMantineTheme(themeOverride);
  const classes = Prism_styles['default']({ theme }, classNames);
  const _styles = core.mergeStyles(classes, styles);
  const clipboard = hooks.useClipboard();
  return /* @__PURE__ */ React__default.createElement("div", __spreadValues({
    className: cx__default(classes.root, className),
    style: __spreadValues(__spreadValues({}, style), _styles.root)
  }, others), !noCopy && /* @__PURE__ */ React__default.createElement(core.Tooltip, {
    className: classes.copy,
    style: _styles.copy,
    label: clipboard.copied ? copiedLabel : copyLabel,
    position: "left",
    placement: "center",
    transition: "fade",
    withArrow: true,
    arrowSize: 4,
    gutter: 8,
    color: clipboard.copied ? "teal" : void 0
  }, /* @__PURE__ */ React__default.createElement(core.ActionIcon, {
    "aria-label": clipboard.copied ? copiedLabel : copyLabel,
    onClick: () => clipboard.copy(children)
  }, clipboard.copied ? /* @__PURE__ */ React__default.createElement(radixIcons_esm.CheckIcon, null) : /* @__PURE__ */ React__default.createElement(radixIcons_esm.ClipboardIcon, null))), /* @__PURE__ */ React__default.createElement(Highlight__default, __spreadProps(__spreadValues({}, Highlight.defaultProps), {
    theme: prismTheme.getPrismTheme(theme),
    code: children,
    language
  }), ({
    className: inheritedClassName,
    style: inheritedStyle,
    tokens,
    getLineProps,
    getTokenProps
  }) => /* @__PURE__ */ React__default.createElement("pre", {
    className: cx__default(classes.code, inheritedClassName, className),
    style: __spreadValues(__spreadValues({}, inheritedStyle), _styles.code)
  }, tokens.map((line, i) => {
    if (i === tokens.length - 1 && line.length === 1 && line[0].content === "\n") {
      return null;
    }
    return /* @__PURE__ */ React__default.createElement("div", __spreadValues({}, getLineProps({ line, key: i })), line.map((token, key) => /* @__PURE__ */ React__default.createElement("span", __spreadValues({}, getTokenProps({ token, key })))));
  }).filter(Boolean))));
}

exports.Prism = Prism;
//# sourceMappingURL=Prism.js.map
