import React from 'react';
import cx from 'clsx';
import Highlight, { defaultProps } from 'prism-react-renderer';
import { useMantineTheme, mergeStyles, Tooltip, ActionIcon } from '@mantine/core';
import { useClipboard } from '@mantine/hooks';
import { CopyIcon } from './CopyIcon.js';
import { getPrismTheme } from './prism-theme.js';
import useStyles from './Prism.styles.js';

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
function Prism(_a) {
  var _b = _a, {
    className,
    style,
    children,
    language,
    noCopy = false,
    themeOverride,
    classNames,
    styles,
    copyLabel = "Copy code",
    copiedLabel = "Copied"
  } = _b, others = __objRest(_b, [
    "className",
    "style",
    "children",
    "language",
    "noCopy",
    "themeOverride",
    "classNames",
    "styles",
    "copyLabel",
    "copiedLabel"
  ]);
  const theme = useMantineTheme(themeOverride);
  const classes = useStyles({ theme }, classNames);
  const _styles = mergeStyles(classes, styles);
  const clipboard = useClipboard();
  return /* @__PURE__ */ React.createElement("div", __spreadValues({
    className: cx(classes.root, className),
    style: __spreadValues(__spreadValues({}, style), _styles.root)
  }, others), !noCopy && /* @__PURE__ */ React.createElement(Tooltip, {
    className: classes.copy,
    style: _styles.copy,
    label: clipboard.copied ? copiedLabel : copyLabel,
    position: "left",
    placement: "center",
    transition: "fade",
    withArrow: true,
    arrowSize: 4,
    gutter: 8,
    color: clipboard.copied ? "teal" : void 0
  }, /* @__PURE__ */ React.createElement(ActionIcon, {
    "aria-label": clipboard.copied ? copiedLabel : copyLabel,
    onClick: () => clipboard.copy(children)
  }, /* @__PURE__ */ React.createElement(CopyIcon, {
    copied: clipboard.copied
  }))), /* @__PURE__ */ React.createElement(Highlight, __spreadProps(__spreadValues({}, defaultProps), {
    theme: getPrismTheme(theme),
    code: children,
    language
  }), ({
    className: inheritedClassName,
    style: inheritedStyle,
    tokens,
    getLineProps,
    getTokenProps
  }) => /* @__PURE__ */ React.createElement("pre", {
    className: cx(classes.code, inheritedClassName, className),
    style: __spreadValues(__spreadValues({}, inheritedStyle), _styles.code)
  }, tokens.map((line, i) => {
    if (i === tokens.length - 1 && line.length === 1 && line[0].content === "\n") {
      return null;
    }
    return /* @__PURE__ */ React.createElement("div", __spreadValues({}, getLineProps({ line, key: i })), line.map((token, key) => /* @__PURE__ */ React.createElement("span", __spreadValues({}, getTokenProps({ token, key })))));
  }).filter(Boolean))));
}

export { Prism };
//# sourceMappingURL=Prism.js.map
